takeout(X,[X|R],R).
takeout(X,[F|R],[F|S]) :- takeout(X,R,S).
perm([],[]).
perm([X|Y],Z) :-perm(Y,W), takeout(X,Z,W).

solve(P) :-
     perm([1,2,3,4,5,6,7,8],P),
     combine([1,2,3,4,5,6,7,8],P,S,D),
     all_diff(S), all_diff(D).

next(0, 1).
next(1, 2).
next(2, 3).
next(3, 4).
next(4, 5).
next(5, 6).
next(6, 7).
next(7, 8).

check_valid([X]).
check_valid([X|Xs] :- 
   is_across_any(X, Xs),
   check_valid(Xs).

is_across(X, [Y|Ys]) :- next(X, Xn), 

combine([X1|X],[Y1|Y],[S1|S],[D1|D]) :-
     S1 is X1+Y1, D1 is X1-Y1,
     combine(X,Y,S,D).
combine([],[],[],[]).

all_diff([X|Y]) :- \+member(X,Y), all_diff(Y).
all_diff([X]).


:- perm([1,2,3],X).
